* 1 aadmn.F
*" PACKAGE AADMIN !"  C[`
*"                  ver 1.00                   92/06/11 numaguti
*"                  SRC:=$GC/model/agcm5/src/admin/aadmn.F
*"                  DOC:=$GC/model/agcm5/doc/main.tex
*"   93/08/29 ۍ␪G  PHYSICS ӕύX
*"   97/09/22 xV  AHSTRG̎dlύX. HISTRG ĂԍۂɃftHg
*" t@C㏑߂(HISTRǦ납6Ԗڂ̈'CON'' ')
***********************************************************************
      PROGRAM GCM5                           !" C[`
*
*"    wSf
*"    Arakawa & Suarez  ЍW
*"    semi implicit scheme
*"    Wߒ, ȗ
*
*   [PARAM]
* 1 include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 include/zhdim.F
* 23 aadmn.F
* PACKAGE ZHDIM  !" 񕶎 
*
*"  [HIS]  90/08/31(numaguti)
*
      INTEGER     NCC
      INTEGER     NDC
      INTEGER     NFILN
*
      PARAMETER ( NCC   = 16, NDC   = 64 ,
     &            NFILN = 100             )
* 1 include/zccom.F
* 24 aadmn.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 25 aadmn.F
*
*   [VAR]
      REAL       GAU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GAV   ( IDIM, JDIM, KMAX )  !" 앗  
      REAL       GAT   ( IDIM, JDIM, KMAX )  !" x  s
      REAL       GAPS  ( IDIM, JDIM       )  !" n\C
      REAL       GAQ   ( IDIM, JDIM, KMAX )  !" 䎼  
      REAL       GAVOR ( IDIM, JDIM, KMAX )  !" Qx  
      REAL       GADIV ( IDIM, JDIM, KMAX )  !" U  c
*"       : iq_f[^(t) <DYNMCS>  iq_f[^(t+t)
*
      REAL       GBU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GBV   ( IDIM, JDIM, KMAX )  !" 앗  
      REAL       GBT   ( IDIM, JDIM, KMAX )  !" x  s
      REAL       GBPS  ( IDIM, JDIM       )  !" n\C
      REAL       GBQ   ( IDIM, JDIM, KMAX )  !" 䎼  
      REAL       GBVOR ( IDIM, JDIM, KMAX )  !" Qx  
      REAL       GBDIV ( IDIM, JDIM, KMAX )  !" U  c
      REAL       GBTG  ( IDIM, JDIM )        !" nʉxs
*"       : iq_f[^(t-t) <DYNMCS>  iq_f[^(t)
*
      REAL       GTUA  ( IDIM, JDIM, KMAX )  !" ^ʕωt`
      REAL       GTVA  ( IDIM, JDIM, KMAX )  !" k^ʕωu`
      REAL       GTH   ( IDIM, JDIM, KMAX )  !" xԕω  g
      REAL       GTR   ( IDIM, JDIM, KMAX )  !" 䎼ԕω  q
*"       : <PHYSCS> iq_ω(P) <DYNMCS> iq_ω(P+D)
*
      INTEGER    ISTEP                 !" ʂXebv
      INTEGER    ITA                   !" ʂ(t)
      INTEGER    ITB                   !" ʂ(t-t)
      INTEGER    IDATEA( 6 )           !" FNb
      INTEGER    IDATEB( 6 )           !" FNb
      REAL       DELT                  !" ԍ݃t
      REAL       DELTP                 !" ߒԍt !"ۍ93/08/29ǉ 
      LOGICAL    OADVNC                !" is邩ۂ
      LOGICAL    ORSTR                 !" ďoo͂邩ۂ
*"       : 
*
*   [ONCE]
      INTEGER    ITSTRT                !" vZJn
      INTEGER    ITEND                 !" vZI
      INTEGER    IORSTR                !" o͊ԊuFďo
*"       : Ǘp[^
*
      INTEGER    IDELT                 !" Wԍ
      INTEGER    INISTP                !" Xebv
      REAL       TFIL                  !" ԃtB^[W
*"       : ԃXebvp[^
*
*"    COMMON /COMCON/ ( include ZCCOM )
*     REAL       CP                    !" C舳M
*     REAL       EL                    !" ̋Ì̐M
*     REAL       ER                    !" na
*     REAL       GRAV                  !" d͉x
*     REAL       RAIR                  !" CC̒萔
*     REAL       RVAP                  !" CC̒萔
*     REAL       CPVAP                 !" C舳M
*     REAL       DH2O                  !" ̖x
*     REAL       EPSV                  !" ƑC̕qʔ
*     REAL       ES0                   !" OOaC
*     REAL       STB                   !" Stefan-Boltzman
*     REAL       FKARM                 !" Karman 萔
*"    COMMON /COMCON/ end
*"       : p[^
*
      REAL       ALAT  ( JDIM )        !" ܓx
      REAL       DLAT  ( JDIM )        !" ܓx׏d
      REAL       ALON  ( IDIM )        !" ox
      REAL       DLON  ( IDIM )        !" ox׏d
      REAL       SIG   ( KMAX )        !" Ѓx()
      REAL       SIGM  (KMAX+1)        !" Ѓx()
      REAL       DSIG  ( KMAX )        !" ()
      REAL       DSIGM (KMAX+1)        !" ()
*"       : Wl
*
*   [WORK]
      COMMON    /COMWRK/ WORK
      REAL       WORK  ( NWORK )       !" [N̈
*
*
*" << SETPUP : ݒ >>
*
      CALL CLCSTR ( 'SETUP' )
      CALL YPREP                       !" VXeO 
*
      CALL SETPAR                      !" p[^
     O         ( ITSTRT, ITEND , IORSTR,
     O           IDELT , INISTP, TFIL    )
*
      CALL SETCOR                      !" Wl
     O         ( ALON  , DLON  ,
     O           ALAT  , DLAT  ,
     O           SIG   , DSIG  ,
     O           SIGM  , DSIGM  )
*
      CALL RDSTRT                      !" l̓ǂݍ݂ƍĐ
     O         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     O           GAVOR , GADIV ,
     O           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     O           GBVOR , GBDIV ,
     O           ITA   , ITB   , IDATEA, IDATEB, ISTEP ,
     C           ITSTRT, ALAT  , DLAT                    )
*
      CALL ADMXMN 
     I         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GADIV , GAVOR , ITA   , 'start GA'      )
      CALL ADMXMN 
     I         ( GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     I           GBDIV , GBVOR , ITB   , 'start GB'      )
*
      CALL RDSTRG                      !" n\l̓ǂݍ
     O         ( GBTG  ,
     I           GBT   ,
     C           ITB     )
*
      CALL SETTIM                      !" L 
     I         ( ITA   , ITB   , IDATEA, IDATEB, ISTEP  )
      CALL AHSTRG                      !" WԕϏo͂̓o^
*
      CALL CLCEND ( 'SETUP' )
*
*  << LOOP : <************* CE[v >>
*
 5000 CONTINUE
*
         ISTEP = ISTEP + 1
*
*     << START : Xebv͂߂̏ >>
*
         CALL CLCSTR ( 'TIMCON' )
*
         CALL TIMSTP                   !" Ԑ 
     O         ( DELT  , OADVNC, ORSTR ,
     I           ITA   , ITB   , IDATEA, IDATEB, ISTEP  ,
     C           IDELT , INISTP, ITEND , IORSTR          )
*
         CALL SAVEGB                   !" t-t̃f[^Z[u
     I         ( GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     I           GBVOR , GBDIV                           )
         CALL CLCEND ( 'TIMCON' )
*
*"    << INTEGR : Ԑϕ >>
* 
        CALL CLCSTR ( 'PHYSCS' )   
*
         DELTP = 2 * DELT                          !" 93/08/29 ۍǉ
*
         CALL PHYSCS                   !" ߒ    93/08/29 ۍύX  
     O         ( GTUA  , GTVA  , GTH   , GTR   , 
     M           GBTG  ,
     I           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     I           GBVOR , GBDIV , 
     I           ITB   , IDATEB, DELTP , DELT , 
     C           ALON  , ALAT  ,
     C           SIG   , SIGM  , DSIG  , DSIGM          )
*
         CALL CLCEND ( 'PHYSCS' )
*
         CALL CLCSTR ( 'DYNMCS' )
*
         CALL DYNMCS                   !" ͊wƎԐϕ
     M         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     M           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     M           GAVOR , GADIV , GBVOR , GBDIV ,
     M           GTUA  , GTVA  , GTH   , GTR   ,
     I           ITA   , DELT  , OADVNC,
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           SIG   , SIGM  , DSIG  , DSIGM           )
*
         CALL CLCEND ( 'DYNMCS' )
*
*
*"    << ADJST : ϕ̒ >>
*
         CALL CLCSTR ( 'PADJST' )
*
         CALL PADJST                   !" 
     M         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GAVOR , GADIV ,
     I           DELT*2.,
     C           SIG   , SIGM  , DSIG   , DSIGM         )
*
         CALL CLCEND ( 'PADJST' )
         CALL CLCSTR ( 'TFILT' )
*
         IF ( OADVNC ) THEN
            CALL TFILT                 !" ^CtB^[
     M         ( GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     M           GBVOR , GBDIV ,
     I           GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GAVOR , GADIV ,
     C           TFIL                                   )
         ENDIF
*
         CALL CLCEND ( 'TFILT' )
*
*"    << OUTPUT : f[^o >>
         IF ( OADVNC ) THEN
            CALL CLCSTR ( 'HISTIN' )
            CALL HISTIN ( GBU   , 'U'   ) !" o̓f[^̋L
            CALL HISTIN ( GBV   , 'V'   )
            CALL HISTIN ( GBT   , 'T'   )
            CALL HISTIN ( GBPS  , 'PS'  )
            CALL HISTIN ( GBQ   , 'Q'   )
            CALL HISTIN ( GBVOR , 'VOR' )
            CALL HISTIN ( GBDIV , 'DIV' )
            CALL HISTIN ( GBTG  , 'TG'  )
            CALL CLCEND ( 'HISTIN' )
*
            CALL CLCSTR ( 'HISTOU' )
            CALL HISTRP
            CALL HISTOU                !" f[^o
            CALL CLCEND ( 'HISTOU' )
         ENDIF
*
*"    << NEXT : ̃Xebv >>
*
         CALL CLCSTR ( 'MISC' )
*
         CALL    ADVSTP                !" ϐi߂
     O         ( ITA   , ITB   , IDATEA, IDATEB,
     I           OADVNC                          )
*
         IF ( ORSTR ) THEN
            CALL WRRSTR                !" X^[gt@C
     I         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GAVOR , GADIV ,
     I           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     I           GBVOR , GBDIV ,
     I           ITA   , ITB   , IDATEA, IDATEB, ISTEP  )
*
            CALL WRRSTG   !" n\X^[gEt@C̏
     I         ( GBTG  ,
     I           ITB   , IDATEB, ISTEP  )
         ENDIF
*
         CALL CLCEND ( 'MISC' )
*
*" << LEND : CE[vI *************> >>
*
      IF ( .NOT. ( ITB .GE. ITEND )  ) GOTO  5000
*
      CALL CLCOUT                      !" CPUԏo
      CALL YFINE                       !" VXe㏈
*
      STOP
      END
***********************************************************************
      SUBROUTINE AHSTRG                !" WԕϏo͂̓o^
*
*   [INTERN PARAM]
      INTEGER    ISTYPL
      DATA       ISTYPL / 1 /
      REAL       VMISS
*
      CALL GZDBGT ( 'MISS', VMISS )   !" l
*
      CALL     HISTRG                  !" o͂̓o^
     I       ( 'U     ', 'u-velocity          ' ,'m/s   ', 'ALEV',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         ' '     , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'V     ', 'v-velocity          ' ,'m/s   ', 'ALEV',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         ' '     , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'T     ', 'temperature         ' ,'K     ', 'ALEV',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         ' '     , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'PS    ', 'surface pressure    ' ,'mb    ', 'ASFC',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         ' '     , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'Q     ', 'specific humidity   ' ,'g/g   ', 'ALEV',
     I           VMISS , VMISS , 1.E-3 , 5.E-3 , ISTYPL  ,
     I         ' '     , '   ' , 0     , 0     , 'X'     ,'(3PF12.3)' )
*
      CALL     HISTRG
     I       ( 'VOR   ', 'vorticity           ' ,'1/s   ', 'ALEV',
     I           VMISS , VMISS , 1.E-6 , 5.E-6 , ISTYPL  ,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(1PE12.3)' )
*
      CALL     HISTRG
     I       ( 'DIV   ', 'divergence          ' ,'1/s   ', 'ALEV',
     I           VMISS , VMISS , 1.E-6 , 5.E-6 , ISTYPL  ,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(1PE12.3)' )
*
      CALL     HISTRG
     I       ( 'TG    ', 'ground temperature  ' ,'K     ', 'ASFC',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         ' '     , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      RETURN
      END
*************************************************************************
      SUBROUTINE ADMXMN        !" debug monitor
     I         ( GDU   , GDV   , GDT   , GDPS  , GDQ   ,
     I           GDDIV , GDVOR , IT    , HLABEL          )
*
*   [PARAM]
* 1 include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 345 aadmn.F
*
*   [INPUT] 
      REAL       GDU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GDV   ( IDIM, JDIM, KMAX )  !" 앗  
      REAL       GDT   ( IDIM, JDIM, KMAX )  !" x  s
      REAL       GDPS  ( IDIM, JDIM       )  !" n\C
      REAL       GDQ   ( IDIM, JDIM, KMAX )  !" 䎼  
      REAL       GDVOR ( IDIM, JDIM, KMAX )  !" Qx  
      REAL       GDDIV ( IDIM, JDIM, KMAX )  !" U  c
      INTEGER    IT
      CHARACTER  HLABEL *(*)
*
      WRITE ( 6,* ) HLABEL, ' IT= ', IT
      CALL MAXMIN( GDU,   IDIM, JDIM, KMAX, IDIM, JDIM, 'U'   )
      CALL MAXMIN( GDV,   IDIM, JDIM, KMAX, IDIM, JDIM, 'V'   )
      CALL MAXMIN( GDT,   IDIM, JDIM, KMAX, IDIM, JDIM, 'T'   )
      CALL MAXMIN( GDPS,  IDIM, JDIM, 1,    IDIM, JDIM, 'PS'  )
      CALL MAXMIN( GDQ,   IDIM, JDIM, KMAX, IDIM, JDIM, 'Q'   )
      CALL MAXMIN( GDVOR, IDIM, JDIM, KMAX, IDIM, JDIM, 'VOR' )
      CALL MAXMIN( GDDIV, IDIM, JDIM, KMAX, IDIM, JDIM, 'DIV' )
*
      RETURN
      END
