* 1 dadmn.F
* PACKAGE DADMN  !" ͊w Cp[g
*"                  ver 1.00                   92/06/12 numaguti
*"                  SRC:=$GC/model/agcm5/src/dynamics/dadmn.F
*"                  DOC:=$GC/model/agcm5/doc/dynamics.tex
**********************************************************************
      SUBROUTINE DYNMCS                      !"  ͊wߒ
     M         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     M           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     M           GAVOR , GADIV , GBVOR , GBDIV ,
     M           GTUA  , GTVA  , GTH   , GTR   ,
     I           IT    , DELT  , OADVNC,
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           SIG   , SIGM  , DSIG  , DSIGM           )
*
*"              semi-implicit Ԑϕ
*"              implicit diffusion
*
*   [PARAM]
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zhdim.F
* 25 dadmn.F
* PACKAGE ZHDIM  !" 񕶎 
*
*"  [HIS]  90/08/31(numaguti)
*
      INTEGER     NCC
      INTEGER     NDC
      INTEGER     NFILN
*
      PARAMETER ( NCC   = 16, NDC   = 64 ,
     &            NFILN = 100             )
* 1 ..\include/zccom.F
* 26 dadmn.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 27 dadmn.F
*
*   [MODIFY]
      REAL       GAU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GAV   ( IDIM, JDIM, KMAX )  !" 앗  
      REAL       GAT   ( IDIM, JDIM, KMAX )  !" x  s
      REAL       GAPS  ( IDIM, JDIM       )  !" n\C
      REAL       GAQ   ( IDIM, JDIM, KMAX )  !" 䎼  
      REAL       GAVOR ( IDIM, JDIM, KMAX )  !" Qx  
      REAL       GADIV ( IDIM, JDIM, KMAX )  !" U  c
*"       : iq_f[^(t) <GENGD> iq_f[^(t+t)
*
      REAL       GBU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GBV   ( IDIM, JDIM, KMAX )  !" 앗  
      REAL       GBT   ( IDIM, JDIM, KMAX )  !" x  s
      REAL       GBPS  ( IDIM, JDIM       )  !" n\C
      REAL       GBQ   ( IDIM, JDIM, KMAX )  !" 䎼  
      REAL       GBVOR ( IDIM, JDIM, KMAX )  !" Qx  
      REAL       GBDIV ( IDIM, JDIM, KMAX )  !" U  c
*"       : iq_f[^(t-t) <MOVGD>  iq_f[^(t)
*
      REAL       GTUA  ( IDIM, JDIM, KMAX )  !" ^ʕωt`
      REAL       GTVA  ( IDIM, JDIM, KMAX )  !" k^ʕωu`
      REAL       GTH   ( IDIM, JDIM, KMAX )  !" xԕω  g
      REAL       GTR   ( IDIM, JDIM, KMAX )  !" 䎼ԕω  q
*"       :  iq_ω𑫂
*
      INTEGER    IT                          !" ʂ
      REAL       DELT                        !" ԍ݃t
      LOGICAL    OADVNC                      !" is邩ۂ
*"       :  ϐ
*
*   [INPUT]
      REAL       ALON  ( IDIM )              !" ox
      REAL       DLON  ( IDIM )              !" ox׏d
      REAL       ALAT  ( JDIM )              !" ܓx
      REAL       DLAT  ( JDIM )              !" ܓx׏d
      REAL       SIG   ( KMAX )              !" Ѓx()
      REAL       SIGM  (KMAX+1)              !" Ѓx()
      REAL       DSIG  ( KMAX )              !" ()
      REAL       DSIGM (KMAX+1)              !" ()
*"        : Wiq
*
*   [INTERNAL SAVE]
      REAL       DMLU  ( NMDIM, KMAX, KMAX ) !" rhŝkt
      INTEGER    KPIV  ( NMDIM, KMAX       ) !" rhs̃s{bg
      REAL       DELTSV                      !" t ̃Z[ul
      DATA       DELTSV / 0.0  /
      SAVE       DMLU, KPIV, DELTSV
*
*   [INTERNAL ONCE]
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" XyNg̓Y
      REAL       FLAPLA( NMDIM  )            !" vVǍW
      REAL       EDEL  ( NMDIM  )            !" āCctCu
*
      REAL       CORIOL ( IDIM, JDIM )       !" RIW 
      REAL       UVFACT ( IDIM, JDIM )       !" uU ̃t@N^[
*
      REAL       DIFV  ( NMDIM  )            !" ^ʐgUW
      REAL       DIFT  ( NMDIM  )            !" MCgUW
*
      REAL       SALPHA( KMAX )              !" Ð̎̌W
      REAL       SBETA ( KMAX )              !" Ð̎̌W
      REAL       SKAPPA( KMAX )              !" xԂ̌W
      REAL       ATF   ( KMAX )              !" xԂ̌W
      REAL       BTF   ( KMAX )              !" xԂ̌W
      REAL       TBAR  ( KMAX )              !" {xFx
      REAL       TBARM ( KMAX )              !" {xF
      REAL       GG    ( KMAX )              !" Z~CvVbgp
      REAL       TMTX  ( KMAX, KMAX )        !" Z~CvVbgp
      REAL       WHMTX ( KMAX, KMAX )        !" Z~CvVbgp
      REAL       GCMTX ( KMAX, KMAX )        !" Z~CvVbgp
*
      REAL       WPHIS ( NMDIM )             !" n\WI|eV
*
      SAVE       NMO   , FLAPLA, EDEL  ,
     &           CORIOL, UVFACT, DIFV  , DIFT  ,
     &           SALPHA, SBETA , SKAPPA,
     &           ATF   , BTF   , TBAR  , TBARM ,
     &           GG    , TMTX  , WHMTX , GCMTX ,
     &           WPHIS
*
      LOGICAL    OSETC , OSETV
      DATA       OSETC , OSETV  / .FALSE., .FALSE.  /
      SAVE       OSETC , OSETV
*
*   [INTERNAL PARAM]
      LOGICAL    ODIASP
      DATA       ODIASP         / .FALSE. /
      SAVE       ODIASP
*
*   [INTERNAL WORK]
      REAL       GAPIX ( IDIM, JDIM       )  !" ΂̓
      REAL       GAPIY ( IDIM, JDIM       )  !" ΂̓k
*        : CXx
*
      REAL       GTKE  ( IDIM, JDIM, KMAX )  !" ^GlM[jd
      REAL       GTUT  ( IDIM, JDIM, KMAX )  !" xڗ  ts
      REAL       GTVT  ( IDIM, JDIM, KMAX )  !" xkڗ  us
      REAL       GTPI  ( IDIM, JDIM       )  !" Cԕω  y
      REAL       GTUQ  ( IDIM, JDIM, KMAX )  !" 䎼ڗ  t
      REAL       GTVQ  ( IDIM, JDIM, KMAX )  !" 䎼kڗ  u
      REAL       GSIGD ( IDIM, JDIM, KMAX+1 )!" Ђ̎ԕω
      REAL       GPID  ( IDIM, JDIM       )  !" ΂̎ԕω
*"       : ԕω
*
      REAL       WDVOR ( NMDIM , KMAX     )  !" Qx  
      REAL       WDDIV ( NMDIM , KMAX     )  !" U  c
      REAL       WDT   ( NMDIM , KMAX     )  !" x  s
      REAL       WDPI  ( NMDIM            )  !" log Ps
      REAL       WDQ   ( NMDIM , KMAX     )  !" 䎼  
*"       : XyNgf[^
*
      REAL       WTVOR ( NMDIM, KMAX      )  !" Qx  
      REAL       WTDIV ( NMDIM, KMAX      )  !" U  c
      REAL       WTT   ( NMDIM, KMAX      )  !" x  s
      REAL       WTPI  ( NMDIM            )  !" logPs 
      REAL       WTQ   ( NMDIM, KMAX      )  !" 䎼  
      REAL       WTVDIF( NMDIM, KMAX      )  !" Qx  
      REAL       WTDDIF( NMDIM, KMAX      )  !" U  c
*"       : XyNgԕω
*
*
*"  << SETCON : 萔ݒ >>
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" XyNg萔ݒ
     O         ( NMO   , FLAPLA, EDEL  ,
     O           CORIOL, UVFACT, DIFV  , DIFT  ,
     C           ALAT  , DLAT                   )
      ENDIF
*   [ONCE]
      IF ( .NOT. OSETV ) THEN
         OSETV = .TRUE.
         CALL    DSETV                 !" 萔ݒ
     O         ( SALPHA, SBETA , SKAPPA,
     O           ATF   , BTF   , TBAR  , TBARM ,
     O           GG    , TMTX  , WHMTX , GCMTX ,
     C           SIG   , SIGM  , DSIG            )
*
         CALL    DHSTRG                !" o͐ݒ
      ENDIF
*
      IF ( DELT .NE. DELTSV ) THEN
         CALL DMTRIX                   !" Z~CvVbgps
     O         ( DMLU  , KPIV  ,
     I           DELT  ,
     C           WHMTX , GCMTX ,
     C           NMO   , ER    , DIFV  , DIFT  )
         DELTSV = DELT
      ENDIF
*
      CALL SETPHS                      !" n\WI|eVݒ
     O         ( WPHIS ,
     I           IT      )
*
*" << TNDNCY : ԕω >>
*
      CALL PIXPIY                      !" n\CXx
     O         ( GAPIX , GAPIY ,
     I           GAPS            )
*
      CALL GRDDYN                      !"  ^͊w
     M         ( GTUA  , GTVA  , GTH   , GTR   ,
     O           GTKE  , GTUT  , GTVT  , GTPI  , GTUQ  , GTVQ  ,
     O           GSIGD , GPID  ,
     I           GAU   , GAV   , GAT   , GAQ   ,
     I           GAVOR , GADIV , GAPIX , GAPIY ,
     C           CORIOL, UVFACT, SIGM  , DSIG  ,
     C           SALPHA, SBETA , SKAPPA,
     C           ATF   , BTF   , TBAR  , TBARM                   )
*
      CALL TENG2W                      !" ԕωXyNg
     O         ( WTVOR , WTDIV , WTT   , WTPI  , WTQ   ,
     I           GTUA  , GTVA  , GTKE  , GTUT  , GTVT  , GTH   ,
     I           GTPI  , GTUQ  , GTVQ  , GTR   ,
     C           FLAPLA                                          )
*
      CALL GD2WD                       !" f[^XyNg
     O         ( WDVOR , WDDIV , WDT   , WDPI  , WDQ   ,
     I           GBVOR , GBDIV , GBT   , GBPS  , GBQ    )
*
*" << INTGR : Ԑϕ >>
*
      CALL TINTGR                      !" XyNgԐϕ
     M         ( WDVOR , WDDIV , WDT   , WDPI  , WDQ   ,
     I           WTVOR , WTDIV , WTT   , WTPI  , WTQ   ,
     I           DMLU  , KPIV  , DELT  ,
     C           DIFV  , DIFT  , FLAPLA, WPHIS ,
     C           GG    , TMTX  , DSIG                   )
*
      IF ( OADVNC ) THEN
         CALL MOVGD                    !" iq_l̎tς
     O         ( GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     O           GBVOR , GBDIV ,
     I           GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GAVOR , GADIV                          )
      ENDIF
*
      CALL GENGD                       !" Viq_l̐
     O         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     O           GAVOR , GADIV ,
     I           WDVOR , WDDIV , WDT   , WDPI  , WDQ   ,
     C           EDEL  , UVFACT                          )
*
*" << CORRCT : ␳ >>
*
      CALL TENDIF                      !" gUɂ鎞ԕω
     O         ( WTVDIF, WTDDIF,
     I           WDVOR , WDDIV ,
     I           DIFV           )
*
      CALL CORDIF                      !" gUCM␳
     M         ( GAT   ,
     I           WTVDIF, WTDDIF,
     I           GAU   , GAV   , DELT  ,
     C           EDEL  , UVFACT         )
*
*" << OUTPUT : o >>
*
      CALL HISTIN ( GSIGD , 'SIGDOT')  !" o͗̈
      CALL HISTIN ( GPID  , 'PIDOT' )
*
      CALL DDIAG                       !" ff
     I         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GAVOR , GADIV                          )
*
      IF ( ODIASP ) THEN
        CALL SPCTLD                    !" XyNgł̐ff
     I         ( WDVOR , 'VOR' , KMAX  , NMO   )
        CALL SPCTLD
     I         ( WDDIV , 'DIV' , KMAX  , NMO   )
        CALL SPCTLD
     I         ( WDT   , 'TMP' , KMAX  , NMO   )
        CALL SPCTLD
     I         ( WDQ   , 'Q'   , KMAX  , NMO   )
        CALL SPCTLD
     I         ( WDPI  , 'PI'  , 1     , NMO   )
      ENDIF
*
      RETURN
*======================================================================
      ENTRY DSTRT                      !" f[^̍Đ
     M         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     O           GAVOR , GADIV ,
     C           ALAT  , DLAT                           )
*
*   [MODIFY]
*     REAL       GAU   ( IDIM, JDIM, KMAX )  !"   
*     REAL       GAV   ( IDIM, JDIM, KMAX )  !" 앗  
*     REAL       GAT   ( IDIM, JDIM, KMAX )  !" x  s
*     REAL       GAPS  ( IDIM, JDIM       )  !" n\C
*     REAL       GAQ   ( IDIM, JDIM, KMAX )  !" 䎼  
*
*   [OUTNPUT]
*     REAL       GAVOR ( IDIM, JDIM, KMAX )  !" Qx  
*     REAL       GADIV ( IDIM, JDIM, KMAX )  !" U  c
*
*   [INPUT]
*     REAL       ALAT  ( JDIM )              !" ܓx
*     REAL       DLAT  ( JDIM )              !" ܓx׏d
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" XyNg萔ݒ
     O         ( NMO   , FLAPLA, EDEL  ,
     O           CORIOL, UVFACT, DIFV  , DIFT  ,
     C           ALAT  , DLAT                   )
      ENDIF
*
      CALL STRTV                       !" f[^Đ
     M         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     O           GAVOR , GADIV ,
     C           EDEL  , UVFACT,
     W           WDVOR , WDDIV , WDT   , WDPI  , WDQ    )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE DHSTRG                !" ͊w֌Wo͂̓o^
*
*   [INTERNAL PARAM]
      INTEGER    ISTYPL
      DATA       ISTYPL / 1 /
*
*   [INTERNAL WORK]
      REAL       VMISS
*
      CALL GZDBGT ( 'MISS' , VMISS )   !" l
*
      CALL HISTRG                      !" o͓o^
     I       ( 'SIGDOT', 'sigma-vertical vel. ' ,'1/s   ', 'AMLEV',
     I           VMISS , VMISS , VMISS , VMISS , ISTYPL  ,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(1PE12.3)' )
*
      CALL HISTRG
     I       ( 'PIDOT ', 'pi-tendency         ' ,'1/s   ', 'ASFC',
     I           VMISS , VMISS , VMISS , VMISS , ISTYPL  ,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(1PE12.3)' )
*
      RETURN
      END
