* 1 dgeng.F
* PACKAGE DGENG  !" ͊w XyNgiq_l
*
************************************************************************
      SUBROUTINE GENGD          !" Viq_l̐
     O         ( GDU   , GDV   , GDT   , GDPS  , GDQ   ,
     O           GDVOR , GDDIV ,
     I           WDVOR , WDDIV , WDT   , WDPI  , WDQ   ,
     C           EDEL  , UVFACT                         )
*
*   [PARAM]
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 15 dgeng.F
*
*   [OUTPUT]
      REAL       GDU   ( IDIM*JDIM, KMAX )   !"   t
      REAL       GDV   ( IDIM*JDIM, KMAX )   !" 앗  u
      REAL       GDT   ( IDIM*JDIM, KMAX )   !" x  s
      REAL       GDPS  ( IDIM*JDIM       )   !" n\C o
      REAL       GDQ   ( IDIM*JDIM, KMAX )   !" 䎼  
      REAL       GDVOR ( IDIM*JDIM, KMAX )   !" Qx  
      REAL       GDDIV ( IDIM*JDIM, KMAX )   !" U  c
*
*   [INPUT]
      REAL       WDVOR ( NMDIM , KMAX     )  !" Qx  
      REAL       WDDIV ( NMDIM , KMAX     )  !" U  c
      REAL       WDT   ( NMDIM , KMAX     )  !" x  s
      REAL       WDPI  ( NMDIM            )  !" log Ps 
      REAL       WDQ   ( NMDIM , KMAX     )  !" 䎼  
*
      REAL       EDEL  ( NMDIM  )            !" ,ct,u
      REAL       UVFACT( IDIM*JDIM )         !" uU ̃t@N^[
*
*   [INTERNAL WORK]
      COMMON    /COMWRK/
     &           WDPSI , WDCHI
      REAL       WDPSI ( NMDIM, KMAX      )  !" /a XyNg
      REAL       WDCHI ( NMDIM, KMAX      )  !" /a XyNg
*
      INTEGER    IJ, K, NM
*
*
*"         < 1. /a, /a ̃XyNg >
*
      DO 1100 K = 1, KMAX
         DO 1100 NM = 1, NMDIM
            WDPSI( NM,K ) = WDVOR( NM,K ) * EDEL( NM )
            WDCHI( NM,K ) = WDDIV( NM,K ) * EDEL( NM )
 1100 CONTINUE
*
*"         < 2. āCcCsC΁Ciq_l >
*
      CALL W2G
     O         ( GDVOR ,
     I           WDVOR ,
     I           '    ', 'POS ', KMAX )
*
      CALL W2G
     O         ( GDDIV ,
     I           WDDIV ,
     I           '    ', 'POS ', KMAX )
*
      CALL W2G
     O         ( GDT   ,
     I           WDT   ,
     I           '    ', 'POSO', KMAX )
*
      CALL W2G
     O         ( GDPS  ,
     I           WDPI  ,
     I           '    ', 'POSO', 1    )
*
      DO 2100 IJ = 1, IDIM*JDIM
         GDPS ( IJ ) = EXP( GDPS( IJ ) )
 2100 CONTINUE
*
      CALL W2G
     O         ( GDQ   ,
     I           WDQ   ,
     I           '    ', 'POSO', KMAX )
*
*"         < 3.  tCu ̊iq_l >
*
      CALL W2G
     O         ( GDU   ,
     I           WDPSI ,
     I           'YGRA', 'NEG ', KMAX )
*
      IF ( MMAX .GE. 1 ) THEN
         CALL W2G
     O         ( GDU   ,
     I           WDCHI ,
     I           'XGRA', 'ADD ', KMAX )
      ENDIF
*
      CALL W2G
     O         ( GDV   ,
     I           WDCHI ,
     I           'YGRA', 'POS ', KMAX )
*
      IF ( MMAX .GE. 1 ) THEN
         CALL W2G
     O         ( GDV   ,
     I           WDPSI ,
     I           'XGRA', 'ADD ', KMAX )
      ENDIF
*
      DO 3100 K = 1, KMAX
         DO 3100 IJ = 1, IDIM*JDIM
            GDU ( IJ,K ) = GDU ( IJ,K ) / UVFACT( IJ )
            GDV ( IJ,K ) = GDV ( IJ,K ) / UVFACT( IJ )
 3100 CONTINUE
*
      RETURN
      END
