* 1 icord.F
* PACKAGE ICORD !" qXg[ Wݒ
*
***********************************************************************
      SUBROUTINE HQCORN    !" Wn̎Q
     I         ( HCORD ,
     O           HALON , HALAT , HASIG ,
     O           KLEVS                   )
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zhdim.F
* 15 icord.F
* PACKAGE ZHDIM  !" 񕶎 
*
*"  [HIS]  90/08/31(numaguti)
*
      INTEGER     NCC
      INTEGER     NDC
      INTEGER     NFILN
*
      PARAMETER ( NCC   = 16, NDC   = 64 ,
     &            NFILN = 100             )
* 16 icord.F
*
*   [INPUT] 
      CHARACTER  HCORD  *(*)                 !" Wn
*
*   [OUTPUT] 
      CHARACTER  HALON  *(*)                 !" 1
      CHARACTER  HALAT  *(*)                 !" 2
      CHARACTER  HASIG  *(*)                 !" 3
*
*   [ENTRY INPUT] 
      CHARACTER  HASIGM *(*)                 !" 3
      REAL       ALON   ( * )                !" 1_
      REAL       ALAT   ( * )                !" 2_
      REAL       ASIG   ( * )                !" 3_
      REAL       ASIGM  ( * )                !" 3_
      REAL       DLON   ( * )                !" 1
      REAL       DLAT   ( * )                !" 2
      REAL       DSIG   ( * )                !" 3
      REAL       DSIGM  ( * )                !" 3
*
*   [INTERNAL SAVE] 
      CHARACTER  HALONZ *(NCC)               !" 1
      CHARACTER  HALATZ *(NCC)               !" 2
      CHARACTER  HASIGZ *(NCC)               !" 3
      CHARACTER  HASIMZ *(NCC)               !" 3
      REAL       ALONZ  ( IMAX )             !" 1_
      REAL       ALATZ  ( JMAX )             !" 2_
      REAL       ASIGZ  ( KMAX )             !" 3_
      REAL       ASIGMZ ( KMAX+1 )           !" 3_
      REAL       DLONZ  ( IMAX )             !" 1
      REAL       DLATZ  ( JMAX )             !" 2
      REAL       DSIGZ  ( KMAX )             !" 3
      REAL       DSIGMZ ( KMAX+1 )           !" 3
      SAVE
*
*   [INTERNAL WORK] 
      INTEGER    KLEVS
*
      HALON  = HALONZ
      HALAT  = HALATZ
*
      IF      ( HCORD .EQ. 'ALEV'  ) THEN
         HASIG  = HASIGZ
         KLEVS  = KMAX
      ELSE IF ( HCORD .EQ. 'AMLEV' ) THEN
         HASIG  = HASIMZ
         KLEVS  = KMAX+1
      ELSE IF ( HCORD .EQ. 'ASFC'  ) THEN
         HASIG  = ' '
         KLEVS  = 1
      ELSE
         CALL MSGDMP( 'W', 'HQCORN', 'UNKNOWN COORDINATE' )
      ENDIF
*
      RETURN
*=====================================================================
      ENTRY      HQCORL      !"  Wx̎Q 
     I         ( HCORD ,
     O           KLEVS  )
*
      IF      ( HCORD .EQ. 'ALEV'  ) THEN
         KLEVS  = KMAX
      ELSE IF ( HCORD .EQ. 'AMLEV' ) THEN
         KLEVS  = KMAX+1
      ELSE IF ( HCORD .EQ. 'ASFC'  ) THEN
         KLEVS  = 1
      ELSE
         CALL MSGDMP( 'W', 'HQCORL', 'UNKNOWN COORDINATE' )
      ENDIF
*
      RETURN
*=====================================================================
      ENTRY      HQCORD      !"  W̎Q 
     I         ( HCORD ,
     O           DLON  , DLAT  , DSIG  ,
     O           KLEVS                   )
*
      CALL COPY ( DLON, DLONZ, IMAX )
      CALL COPY ( DLAT, DLATZ, JMAX )
      IF      ( HCORD .EQ. 'ALEV'  ) THEN
         CALL COPY ( DSIG, DSIGZ,  KMAX )
         KLEVS  = KMAX
      ELSE IF ( HCORD .EQ. 'AMLEV' ) THEN
         CALL COPY ( DSIG, DSIGMZ, KMAX )
         KLEVS  = KMAX+1
      ELSE IF ( HCORD .EQ. 'ASFC'  ) THEN
         DSIG( 1 ) = 1.0
         KLEVS  = 1
      ELSE
         CALL MSGDMP( 'W', 'HQCORD', 'UNKNOWN COORDINATE' )
      ENDIF
*
      RETURN
*=====================================================================
      ENTRY      HQCORP      !"  W_̎Q 
     I         ( HCORD ,
     O           ALON  , ALAT  , ASIG  ,
     O           KLEVS                   )
*
      CALL COPY ( ALON, ALONZ, IMAX )
      CALL COPY ( ALAT, ALATZ, JMAX )
      IF      ( HCORD .EQ. 'ALEV'  ) THEN
         CALL COPY ( ASIG, ASIGZ,  KMAX )
         KLEVS  = KMAX
      ELSE IF ( HCORD .EQ. 'AMLEV' ) THEN
         CALL COPY ( ASIG, ASIGMZ, KMAX )
         KLEVS  = KMAX+1
      ELSE IF ( HCORD .EQ. 'ASFC'  ) THEN
         ASIG( 1 ) = 1.0
         KLEVS  = 1
      ELSE
         CALL MSGDMP( 'W', 'HQCORP', 'UNKNOWN COORDINATE' )
      ENDIF
*
      RETURN
*=====================================================================
      ENTRY      HSCORD      !"  Wn̐ݒ 
     I         ( HALON , HALAT , HASIG , HASIGM,
     I           ALON  , ALAT  , ASIG  , ASIGM ,
     I           DLON  , DLAT  , DSIG  , DSIGM  )
*
      HALONZ = HALON
      HALATZ = HALAT
      HASIGZ = HASIG
      HASIMZ = HASIGM
*
      CALL COPY ( ALONZ , ALON  , IMAX   )
      CALL COPY ( ALATZ , ALAT  , JMAX   )
      CALL COPY ( ASIGZ , ASIG  , KMAX   )
      CALL COPY ( ASIGMZ, ASIGM , KMAX+1 )
*
      CALL COPY ( DLONZ , DLON  , IMAX   )
      CALL COPY ( DLATZ , DLAT  , JMAX   )
      CALL COPY ( DSIGZ , DSIG  , KMAX   )
      CALL COPY ( DSIGMZ, DSIGM , KMAX+1 )
*
      RETURN
*=====================================================================
      ENTRY      HSCORN      !"  W̐ݒ 
     I         ( HALON , HALAT , HASIG , HASIGM )
*
      HALONZ = HALON
      HALATZ = HALAT
      HASIGZ = HASIG
      HASIMZ = HASIGM
*
      RETURN
      END
