* 1 p2gra0.F
* PACKAGE P2GRAV !" ʪ(2) (ߡ)
* 
********************************************************************* 
      SUBROUTINE GRAVTY          !" 
     O         ( UTG    , VTG    , TAUXG  , TAUYG  , 
     I           GDZSD  , IDSFC  , 
     I           GDU    , GDV    , GDT    , GDP    , GDTG   , 
     I           GDZ    , GDTM   , GDPM                       )
* 
*" [HIS] 92/07/20(takepiro)
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 18 p2gra0.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 19 p2gra0.F
* 
*   [OUTPUT] 
      REAL      UTG   ( IDIM*JDIM, KMAX )   !" U TENDENCY BY GRAVITY 
      REAL      VTG   ( IDIM*JDIM, KMAX )   !" V TENDENCY BY GRAVITY 
      REAL      TAUXG ( IDIM*JDIM, KMAX+1 ) !" U GRAVITY MOMENTUM 
      REAL      TAUYG ( IDIM*JDIM, KMAX+1 ) !" V GRAVITY MOMENTUM 
* 
*   [INPUT] 
      REAL      GDZSD ( IDIM*JDIM )         !" STANDARD DEVIATION 
      INTEGER   IDSFC ( IDIM*JDIM )         !" SURFACE INDEX 
      REAL      GDU   ( IDIM*JDIM, KMAX )   !" WESTERLY 
      REAL      GDV   ( IDIM*JDIM, KMAX )   !" SOUTHERLY WIND 
      REAL      GDT   ( IDIM*JDIM, KMAX )   !" TEMPERATURE 
      REAL      GDP   ( IDIM*JDIM, KMAX )   !" PRESSURE 
      REAL      GDTG  ( IDIM*JDIM )         !" SURFACE TEMPERATURE 
      REAL      GDZ   ( IDIM*JDIM, KMAX )   !" HEIGHT 
* 
      REAL      GDTM  ( IDIM*JDIM, KMAX+1 ) !" TEMPERATURE(INTERFACE) 
      REAL      GDPM  ( IDIM*JDIM, KMAX+1 ) !" PRESSURE(INTERFACE) 
* 
*   [INTERNAL PARM] 
      LOGICAL OFIRST 
      DATA    OFIRST /  .TRUE.  / 
      SAVE
*
      INTEGER    IJ, K
* 
*          < 0.0 GRAVITY WAVE DRAG PARAMETERS >
* 
      IF ( OFIRST ) THEN 
         WRITE ( 6,* ) ' DUMMY GRAVITY WAVE DRAG -  92/07/20' 
         OFIRST = .FALSE. 
      ENDIF 
* 
* 
*          < 1.  SET DUMMY VALUES > 
* 
      DO 3100 K = 1, KMAX 
         DO 3100 IJ = 1, IDIM*JDIM
               UTG  ( IJ,K ) = 0.  
               VTG  ( IJ,K ) = 0.  
               TAUXG( IJ,K ) = 0.  
               TAUYG( IJ,K ) = 0.  
 3100 CONTINUE 
* 
      RETURN 
      END 
