* 1 p2dadj.F
* PACKAGE P2DADJ      !" ʪ(2) ήĴ
*
*"  [HIS] 90/05/19(numaguti)
*
**********************************************************************
      SUBROUTINE DADJST   !" ήĴ
     M         ( GDT   ,
     I           GDP   , GDPM  , DELTA  )
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 16 p2dadj.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 17 p2dadj.F
*
*   [MODIFY] 
      REAL       GDT   ( IDIM*JDIM, KMAX )   !"   
*
*   [INPUT] 
      REAL       GDP   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDPM  ( IDIM*JDIM, KMAX+1 ) !" Ⱦ
      REAL       DELTA                       !" 2 t
*
*   [INTERNAL PARM] 
      INTEGER    ITRMAX
      PARAMETER (ITRMAX=10)
      REAL       EPST ( ITRMAX )             !" ԰εƸ
      DATA       EPST / 0.01  , 0.02  , 0.02  , 0.05  , 0.05  ,
     &                  0.10  , 0.10  , 0.20  , 0.20  , 0.40    /
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           ADJDA , ADJDB ,
     &           DELP  , DPDP  , DPPMK
      REAL       ADJDA ( IDIM*JDIM )         !" Ĵᤵ줿ݤ
      REAL       ADJDB ( IDIM*JDIM )         !" Ĵᤵ줿ݤ
      REAL       DELP  ( IDIM*JDIM, KMAX )   !" 
      REAL       DPDP  ( IDIM*JDIM, KMAX )   !" ե
      REAL       DPPMK ( IDIM*JDIM, KMAX )   !" ե
      INTEGER    I, J, IJ, K, ITR
      REAL       ST, DT, ADJPTS
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' DRY CONVENCIVE ADJUSTMENT P2.1 DATE=90/08/31'
         OFIRST = .FALSE.
      ENDIF
*
*"      < 1. ե׻ >
*
      DO 1100 K = 1, KMAX
         DO 1100 IJ = 1, IDIM*JDIM
            DELP  ( IJ,K ) = GDPM( IJ,K   ) - GDPM( IJ,K+1 )
 1100 CONTINUE
*
      DO 1200 K = 2, KMAX
         DO 1200 IJ = 1, IDIM*JDIM
            DPDP  ( IJ,K ) = DELP( IJ,K ) / DELP( IJ,K-1 )
            DPPMK ( IJ,K ) = RAIR / CP
     &                       * ( GDP ( IJ,K-1 ) - GDP ( IJ,K   ) )
     &                       / ( DELP( IJ,K-1 ) + DELP( IJ,K   ) )
     &                       /   GDPM( IJ,K   )
 1200 CONTINUE
*
*"      < 2. Ĵ >
*
      CALL RESET ( ADJDB,  IDIM*JDIM )
      DO 2000 I = 1, IMAX
         DO 2000 J = 1, JMAX
            ADJDB( IDIM*(J-1)+I ) = 1.  
 2000 CONTINUE
*
*"          < ƥ졼 >
*
      DO 2100 ITR = 1, ITRMAX
*
         CALL RESET ( ADJDA, IDIM*JDIM )
*
         DO 2120 K = 2, KMAX
*
            DO 2130 IJ = 1, IDIM*JDIM
*
               IF ( ADJDB( IJ ) .GT. 0.9   ) THEN
                  ST   =   GDT ( IJ,K-1 ) - GDT ( IJ,K )
     &                   - DPPMK ( IJ,K )
     &                     * (  DELP( IJ,K-1 ) * GDT ( IJ,K-1 )
     &                        + DELP( IJ,K   ) * GDT ( IJ,K   ) )
*
                  IF ( ST .GT. EPST( ITR ) ) THEN
                     DT = ST / ( 1. + DPDP( IJ,K ) )
                     GDT  ( IJ,K   ) = GDT( IJ,K   ) + DT
                     GDT  ( IJ,K-1 ) = GDT( IJ,K-1 ) - DT * DPDP( IJ,K )
                     ADJDA( IJ )     = 1.  
                  ENDIF
*
               ENDIF
 2130       CONTINUE
*
 2120    CONTINUE
*
         ADJPTS = 0.
         DO 2140 IJ = 1, IDIM*JDIM
            ADJDB( IJ ) = ADJDA( IJ )
            ADJPTS = ADJPTS + ADJDA( IJ )
 2140    CONTINUE
*
         IF ( ADJPTS .LT. 1. ) GOTO 2200
*"                                  exit
*
 2100 CONTINUE
*
 2200 CONTINUE
*
      RETURN
      END
