* 1 p2diag.F
* PACKAGE P2DIAG  !" ʪ(2) 
*
************************************************************************
      SUBROUTINE PDIAG       !" ʪο
     I      ( TFLUX , QFLUX , RFLUX , SFLUX ,
     I        GTT   , GTQ   , GTTG  ,
     I        GDT   , GDQ   , GDTG  , GDPM  ,
     C        GRHC                            )
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 16 p2diag.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 17 p2diag.F
*
*   [INPUT]
      REAL       TFLUX  ( IDIM*JDIM, KMAX+1)  !" ԤΥեå
      REAL       QFLUX  ( IDIM*JDIM, KMAX+1)  !" Υեå
      REAL       RFLUX  ( IDIM*JDIM, KMAX+1)  !" Ĺȥեå
      REAL       SFLUX  ( IDIM*JDIM, KMAX+1)  !" ûȥեå
*
      REAL       GTT   ( IDIM*JDIM, KMAX )    !" ٻѲ 
      REAL       GTQ   ( IDIM*JDIM, KMAX )    !" 漾Ѳ 
      REAL       GTTG  ( IDIM*JDIM )          !" ɽѲΨ
      REAL       GDT   ( IDIM*JDIM, KMAX )    !"   
      REAL       GDQ   ( IDIM*JDIM, KMAX )    !" 漾  
      REAL       GDTG  ( IDIM*JDIM )          !" ɽ̲
      REAL       GDPM  ( IDIM*JDIM, KMAX+1 )  !"  
      REAL       GRHC  ( IDIM*JDIM )          !" ɽǮ
*
*   [INTERNAL WORK] 
      LOGICAL    ODIAG
      INTEGER    JFLDIA, NCOLS, ISTR, IEND, IINT
      INTEGER    IJ, K
      REAL       SRFLUX, SHFLUX, SQFLUX, CHGHG
      REAL       SSFLUX, TSFLUX, TRFLUX
      REAL       DTTOT, DQTOT
*
*
      CALL QDIAGP
     O         ( ODIAG , JFLDIA, NCOLS ,
     O           ISTR  , IEND  , IINT  ,
     I           1                       )
*
      IF ( .NOT. ODIAG )                RETURN
*
      DO 5100 IJ = ISTR, IEND, IINT
         SRFLUX = RFLUX( IJ,1 )
         SHFLUX = TFLUX( IJ,1 )
         SQFLUX = QFLUX( IJ,1 )
         CHGHG  = GRHC ( IJ   ) * GTTG( IJ )
         SSFLUX = SFLUX( IJ,1 )
         TSFLUX = SFLUX( IJ,KMAX+1 )
         TRFLUX = RFLUX( IJ,KMAX+1 )
*
         DTTOT = 0.  
         DQTOT = 0.  
         DO 5120  K = 1, KMAX
            DTTOT = DTTOT + GTT  ( IJ,K )
     &                      * ( GDPM( IJ,K )-GDPM( IJ,K+1 ) )*CP/GRAV
            DQTOT = DQTOT + GTQ  ( IJ,K )
     &                      * ( GDPM( IJ,K )-GDPM( IJ,K+1 ) )*EL/GRAV
 5120    CONTINUE
*
         WRITE ( JFLDIA,* )  'SURFACE FLUX H,R,E,G',
     &                       SHFLUX, SRFLUX , SQFLUX, CHGHG
         WRITE ( JFLDIA,* )  'SURFACE BUDGET   N,S',
     &                       SRFLUX+SHFLUX+CHGHG+SQFLUX, -SSFLUX
         WRITE ( JFLDIA,* )  'RADIATION BUDGET L,S',
     &                       TRFLUX, -TSFLUX
         WRITE ( JFLDIA,* )  'ENERGY BUDGET  FC,DT',
     &                       SHFLUX+SRFLUX+SSFLUX-TSFLUX-TRFLUX, DTTOT
         WRITE ( JFLDIA,* )  'WATER BUDGET   FC,DQ',
     &                       SQFLUX, DQTOT
*
 5100 CONTINUE
*
      RETURN
      END
************************************************************************
      SUBROUTINE PDIAG2       !" ʪο(2)
     I         ( GQPR  )
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 93 p2diag.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 94 p2diag.F
*
*   [INPUT] 
      REAL       GQPR  ( IDIM*JDIM )          !" ߿
*
*   [INTERNAL WORK] 
      LOGICAL    ODIAG
      INTEGER    JFLDIA, NCOLS, ISTR, IEND, IINT
      INTEGER    IJ
*
      CALL QDIAGP
     O         ( ODIAG , JFLDIA, NCOLS ,
     O           ISTR  , IEND  , IINT  ,
     I           1                       )
*
      IF ( .NOT. ODIAG )                RETURN
*
      DO 5100 IJ = ISTR, IEND, IINT
*
         WRITE ( JFLDIA,* )  'PRECIPITATION       ',
     &                       GQPR( IJ )
*
 5100 CONTINUE
*
      RETURN
      END
