* 1 p2mlsc.F
* PACKAGE P2MLSC  !" ʪ(2) 絬϶ŷ
*
**********************************************************************
      SUBROUTINE LSCOND      !" 絬϶ŷ
     M         ( GDT   , GDQ   ,
     M           GQPR  , GQLSC , GSLSC ,
     I           GDP   , GDPM  , DELTA  )
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 15 p2mlsc.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 16 p2mlsc.F
*
*   [MODIFY] 
      REAL       GDT   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDQ   ( IDIM*JDIM, KMAX )   !" 漾  
      REAL       GQPR  ( IDIM*JDIM       )   !" ߿
      REAL       GQLSC ( IDIM*JDIM, KMAX )   !" ŷǮΨ
      REAL       GSLSC ( IDIM*JDIM, KMAX )   !" ŷ漾Ѳ
*
*   [INPUT] 
      REAL       GDP    ( IDIM*JDIM, KMAX )  !"   
      REAL       GDPM   ( IDIM*JDIM, KMAX+1 )!" Ⱦ
      REAL       DELTA                       !" 2t
*
*   [INTERNAL PARM] 
      REAL       RCRITL                      !" ׳м
      DATA       RCRITL / 1.0   /
      NAMELIST  /NMMLSC/ RCRITL
      SAVE       RCRITL
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE       OFIRST
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           GDQB
      REAL       GDQB  ( IDIM*JDIM, KMAX )   !" Ĵ漾
*
      INTEGER    IJ, K
      INTEGER    IFPAR, JFPAR
      REAL       ELF
      REAL       QSAT, DQSAT, QEXE, DT, DQ
*      
* 1 ..\include/zqsat.F
* PACKAGE ZQSAT     !" Clausis-Clapeyron ̎(֐)
*
*"    QSAT:  saturation water vapour mixing ratio
*"    DQSAT: d(QSAT)/d(T)
*
      REAL       FQSAT
      REAL       FDQSAT
      REAL       T, P, QS
*
      FQSAT ( T,P )    = EPSV * ES0
     &                   * EXP( EL/RVAP *( 1./273. - 1./T ) )
     &                   / P
      FDQSAT( T,QS )   = EL * QS / ( RVAP * T*T )
* 54 p2mlsc.F
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' LARGE SCALE CONDENSATION P2.1 DATE=90/09/12'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMMLSC, END=190 )
  190    WRITE  ( JFPAR, NMMLSC )
      ENDIF
*
      ELF = EL / CP
*
      DO 200 K = 1, KMAX
         DO 200 IJ = 1, IDIM*JDIM
            GDQB ( IJ,K ) = GDQ ( IJ,K )
  200 CONTINUE
*
*"         < 1. Ĵ >
*
      DO 1000 K = KMAX, 1, -1
         DO 1000 IJ = 1, IDIM*JDIM
*
            QSAT   = FQSAT ( GDT( IJ,K ), GDP( IJ,K ) )
*
            IF ( GDQ ( IJ,K )/QSAT .GE. RCRITL ) THEN
*"                                                [ ˰ ]
*
               DQSAT  = FDQSAT( GDT( IJ,K   ), QSAT  )
*
               QEXE   = GDQ ( IJ,K ) - QSAT
               DT     = ELF * QEXE / ( 1. + ELF * DQSAT )
               DQ     = DQSAT * DT
*
               GDT   ( IJ,K ) = GDT( IJ,K ) + DT
               GDQ   ( IJ,K ) = QSAT + DQ
*
               GQLSC ( IJ,K ) = GQLSC( IJ,K ) + DT / DELTA
               GQPR  ( IJ )   = GQPR( IJ )
     &                        + DT * CP / DELTA
     &                          * ( GDPM( IJ,K )-GDPM( IJ,K+1 ) )/GRAV
*
*"             ------------- iteration (1) ----------------------------
*
               QSAT   = FQSAT ( GDT( IJ,K ), GDP( IJ,K ) )
               DQSAT  = FDQSAT( GDT( IJ,K ), QSAT  )
*
               QEXE   = GDQ ( IJ,K ) - QSAT
               DT     = ELF * QEXE / ( 1. + ELF * DQSAT )
               DQ     = DQSAT * DT
*
               GDT   ( IJ,K ) = GDT( IJ,K ) + DT
               GDQ   ( IJ,K ) = QSAT + DQ
*
               GQLSC ( IJ,K ) = GQLSC( IJ,K ) + DT / DELTA
               GQPR  ( IJ )   = GQPR( IJ )
     &                        + DT * CP / DELTA
     &                          * ( GDPM( IJ,K )-GDPM( IJ,K+1 ) )/GRAV
*
*"             ------------- iteration (2) ----------------------------
*
               QSAT   = FQSAT ( GDT( IJ,K ), GDP( IJ,K ) )
               DQSAT  = FDQSAT( GDT( IJ,K ), QSAT  )
*
               QEXE   = GDQ ( IJ,K ) - QSAT
               DT     = ELF * QEXE / ( 1. + ELF * DQSAT )
               DQ     = DQSAT * DT
*
               GDT   ( IJ,K ) = GDT( IJ,K ) + DT
               GDQ   ( IJ,K ) = QSAT + DQ
*
               GQLSC ( IJ,K ) = GQLSC( IJ,K ) + DT / DELTA
               GQPR  ( IJ )   = GQPR( IJ )
     &                        + DT * CP / DELTA
     &                          * ( GDPM( IJ,K )-GDPM( IJ,K+1 ) )/GRAV
*
               GSLSC ( IJ,K ) = GSLSC( IJ,K )
     &                        + ( GDQ( IJ,K ) - GDQB( IJ,K ) )/DELTA
*
            ENDIF
 1000 CONTINUE
*
      RETURN
      END
