* 1 p2sfcl.F
* PACKAGE P2SFCL  !" ʪ(2) ɽХ륯
***********************************************************************
      SUBROUTINE BLKCOF          !" Х륯
     O         ( CM    , CH    , CE    ,
     I           RIB   , VABS  , GRZ0M , GRZ0H , ZA    )
*
*"         Luois Bulk Coeff.
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 15 p2sfcl.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 16 p2sfcl.F
*
*   [OUTPUT] 
      REAL       CM    ( IDIM*JDIM )         !" Х륯
      REAL       CH    ( IDIM*JDIM )         !" Х륯
      REAL       CE    ( IDIM*JDIM )         !" Х륯
*
*   [INPUT] 
      REAL       RIB   ( IDIM*JDIM )         !" Х륯ң
      REAL       VABS  ( IDIM*JDIM )         !" ®
      REAL       GRZ0M ( IDIM*JDIM )         !" ɽ١ʱư̡
      REAL       GRZ0H ( IDIM*JDIM )         !" ɽ١Ǯ
      REAL       ZA    ( IDIM*JDIM )         !" ǲع
*
*   [INTERNAL PARM] 
      LOGICAL    NEWTRL
      DATA       NEWTRL / .FALSE. /
      REAL       CHCONS
      REAL       CMMIN, CHMIN, CEMIN
      REAL       CMMAX, CHMAX, CEMAX
      DATA       CHCONS /  -1.   /
      DATA       CMMIN  /   0.   /           !" Х륯Ǿ
      DATA       CHMIN  /   0.   /           !" ԥХ륯Ǿ
      DATA       CEMIN  /   0.   /           !" Х륯Ǿ
      DATA       CMMAX  /   1.   /           !" Х륯
      DATA       CHMAX  /   1.   /           !" ԥХ륯
      DATA       CEMAX  /   1.   /           !" Х륯
*
      NAMELIST  /NMSFCL/ NEWTRL, CHCONS,
     &                   CMMIN , CHMIN , CEMIN ,
     &                   CMMAX , CHMAX , CEMAX
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      INTEGER    IJ
      INTEGER    IFPAR, JFPAR
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' SURFACE BULK COEF. Louis - P2.1 DATE=90/11/19'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMSFCL, END=190 )
  190    WRITE  ( JFPAR, NMSFCL )
*
      ENDIF
*
*"         < 1. ΩХ륯 >
*
      IF ( CHCONS .LT. 0.   ) THEN
*
         DO 1100 IJ = 1, IDIM*JDIM
            CM ( IJ ) = (  FKARM / LOG( ZA( IJ )/GRZ0M( IJ ) )  )**2
            CH ( IJ ) = (  FKARM / LOG( ZA( IJ )/GRZ0H( IJ ) )  )**2
            CE ( IJ ) = CH ( IJ )
 1100    CONTINUE
*
      ELSE
         DO 1200 IJ = 1, IDIM*JDIM
            CM ( IJ ) = CHCONS
            CH ( IJ ) = CHCONS
            CE ( IJ ) = CHCONS
 1200    CONTINUE
      ENDIF
*
*"         < 2. Ω >
*
      IF ( .NOT. NEWTRL ) THEN
*
         DO 2100 IJ = 1, IDIM*JDIM
*
            IF ( RIB( IJ ) .GT. 0.   ) THEN
               CM ( IJ ) = CM ( IJ )
     &                     / ( 1. + 10.*RIB( IJ )
     &                                / SQRT( 1.+5.*RIB( IJ ) )  )
*
               CH ( IJ ) = CH ( IJ )
     &                     / ( 1. + 15.*RIB( IJ )
     &                                * SQRT( 1.+5.*RIB( IJ ) )  )
*
               CE ( IJ ) = CH ( IJ )
*
            ELSE
               CM ( IJ ) = CM ( IJ )
     &                     * ( 1. - 10.*RIB( IJ )
     &                             / ( 1. + 75.*CM( IJ )
     &                                    * SQRT( -ZA( IJ )/GRZ0M( IJ )
     &                                          * RIB( IJ )            )
     &                             )
     &                    )
*
               CH ( IJ ) = CH ( IJ )
     &                     * ( 1. - 15.*RIB( IJ )
     &                             / ( 1. + 75.*CH( IJ )
     &                                    * SQRT( -ZA( IJ )/GRZ0H( IJ )
     &                                          * RIB( IJ )            )
     &                             )
     &                    )
*
               CE ( IJ ) = CH ( IJ )
            ENDIF
 2100    CONTINUE
*
      ENDIF
*
      DO 2200 IJ = 1, IDIM*JDIM
         CM ( IJ ) = MAX(  MIN( CM ( IJ ), CMMAX ), CMMIN  )
         CH ( IJ ) = MAX(  MIN( CH ( IJ ), CHMAX ), CHMIN  )
         CE ( IJ ) = MAX(  MIN( CE ( IJ ), CEMAX ), CEMIN  )
 2200 CONTINUE
*
      RETURN
      END
