* PACKAGE DHYDR       !" ͊w Ð GCM5(DHYDR)
*
***********************************************************************
      SUBROUTINE WHYDRO     !" Ð̎ ( XyNg )
     O         ( WDPHI ,
     I           WDT    )
*
*"                 Arakawa & Suarez  ЍW
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" iq_, g
      INCLUDE   (ZCCOM)                      !" W萔
#else
#include        "zcdim.F"                    !" iq_, g
#include        "zccom.F"                    !" W萔
#endif
*
*   [OUTPUT] 
      REAL       WDPHI ( NMDIM, KMAX )       !" x  
      REAL       WDT   ( NMDIM , KMAX     )  !" x  s
*
*   [INPUT] 
      REAL       GDPHI ( IDIM*JDIM, KMAX )   !" x  
      REAL       GDT   ( IDIM*JDIM, KMAX )   !" x  s
*
      REAL       SALPHA( KMAX )              !" Ð̎̌W 
      REAL       SBETA ( KMAX )              !" Ð̎̌W 
*
*   [ENTRY INPUT] 
      REAL       SIG   ( KMAX )              !" Ѓx()
      REAL       SIGM  ( KMAX+1 )            !" Ѓx()
*
*   [INTERNAL SAVE] 
      REAL       SALPHZ( KMAX )              !" Ð̎̌W 
      REAL       SBETZ ( KMAX )              !" Ð̎̌W 
      LOGICAL    OSET                        !" 萔ZbgtO
      DATA       OSET / .FALSE. /
      SAVE       SALPHZ , SBETZ, OSET
*   [INTERNAL WORK] 
      INTEGER    IJ, K, NM
      REAL       AKAPPA
*
      IF ( .NOT. OSET ) THEN
         CALL MSGDMP( 'E','WHYDRO','CONSTANTS ARE NOT SET.')
      ENDIF
*
*"         < 1. XyNgԂł̐ςݏグ >
*
      DO 1100 NM = 1, NMDIM
            WDPHI ( NM,1 ) = CP * SALPHZ( 1 ) * WDT ( NM,1 )
 1100 CONTINUE
*
      DO 1200 K = 2, KMAX
         DO 1200 NM = 1, NMDIM
            WDPHI ( NM,K ) = WDPHI( NM,K-1 )
     &                          + CP * SALPHZ( K   ) * WDT ( NM,K   )
     &                          + CP * SBETZ ( K-1 ) * WDT ( NM,K-1 )
 1200 CONTINUE
*
      RETURN
*======================================================================
      ENTRY      GHYDRO     !" Ð̎ ( iq_ )
     O         ( GDPHI ,
     I           GDT     )
*
      IF ( .NOT. OSET ) THEN
         CALL MSGDMP( 'E','GHYDRO','CONSTANTS ARE NOT SET.')
      ENDIF
*
*"         < 2. iqԂł̐ςݏグ >
*
      DO 2100 IJ = 1, IDIM*JDIM
            GDPHI ( IJ,1 ) = CP * SALPHZ( 1   ) * GDT ( IJ,1 )
 2100 CONTINUE
*
      DO 2200 K = 2, KMAX
         DO 2200 IJ = 1, IDIM*JDIM
            GDPHI ( IJ,K ) = GDPHI( IJ,K-1 )
     &                     + CP * SALPHZ( K   ) * GDT ( IJ,K   )
     &                     + CP * SBETZ ( K-1 ) * GDT ( IJ,K-1 )
 2200 CONTINUE
*
      RETURN
*======================================================================
      ENTRY      HYDROS         !" Ð̌W̐ݒ
     I         ( SIG   , SIGM  )
*
      AKAPPA = RAIR / CP
      DO 3100 K = 1, KMAX
         SALPHZ( K ) =        ( SIGM( K   )/SIG ( K ) )**AKAPPA - 1.  
         SBETZ ( K ) = 1.   - ( SIGM( K+1 )/SIG ( K ) )**AKAPPA
 3100 CONTINUE
*
      OSET = .TRUE.
*
      RETURN
*===================================================================
      ENTRY      HYDROQ       !" Ð̌W̎Q
     O         ( SALPHA, SBETA )
*
      CALL COPY ( SALPHA, SALPHZ, KMAX )
      CALL COPY ( SBETA , SBETZ , KMAX )
*
      RETURN
      END
