* PACKAGE DINTG  !" ͊w Ԑϕ
*
*"[]  97/05/19 xV bug fix
***********************************************************************
      SUBROUTINE TINTGR         !" Ԑϕ ( XyNg )
     M         ( WDVOR , WDDIV , WDT   , WDPI  , WDQ   ,
     I           WTVOR , WTDIV , WTT   , WTPI  , WTQ   ,
     I           DMLU  , KPIV  , DELT  ,
     C           DIFV  , DIFT  , FLAPLA, WPHIS ,
     C           GG    , TMTX  , DSIG                   )
*
*"                 Arakawa & Suarez  ЍW
*"                   semi implicit scheme
*"                   implicit horizontal diffusion
*
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" iq_Cg
#else
#include        "zcdim.F"                    !" iq_Cg
#endif
*
*   [MODIFY] 
      REAL       WDVOR ( NMDIM , KMAX     )  !" Qx  
      REAL       WDDIV ( NMDIM , KMAX     )  !" U  c
      REAL       WDT   ( NMDIM , KMAX     )  !" x  s
      REAL       WDPI  ( NMDIM            )  !" log Ps 
      REAL       WDQ   ( NMDIM , KMAX     )  !" 䎼  
*
*   [INPUT] 
      REAL       WTVOR ( NMDIM, KMAX      )  !" Qx   ԕω
      REAL       WTDIV ( NMDIM, KMAX      )  !" U  c ԕω
      REAL       WTT   ( NMDIM, KMAX      )  !" x  s ԕω
      REAL       WTPI  ( NMDIM            )  !" logPs  ԕω
      REAL       WTQ   ( NMDIM, KMAX      )  !" 䎼   ԕω
*
      REAL       DMLU  ( NMDIM, KMAX, KMAX ) !" rhŝkt
      INTEGER    KPIV  ( NMDIM, KMAX       ) !" rhs̃s{bg
      REAL       DELT                        !" ԍ݃t
*
      REAL       DIFV  ( NMDIM  )            !" ^ʐgUW
      REAL       DIFT  ( NMDIM  )            !" MCgUW
      REAL       FLAPLA( NMDIM  )            !" vVǍW
      REAL       WPHIS ( NMDIM )             !" n\WI|eV
*
      REAL       GG    ( KMAX )              !" Z~CvVbgp
      REAL       TMTX  ( KMAX, KMAX )        !" Z~CvVbgp
      REAL       DSIG  ( KMAX )              !" 
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           WDTX  , WDPIX ,
     &           WDPHIX, WBRDIV
      REAL       WDTX     ( NMDIM, KMAX )    !" x(ϕ)
      REAL       WDPIX    ( NMDIM )          !"   (ϕ)
      REAL       WDPHIX   ( NMDIM, KMAX )    !"   (ϕ)
      REAL       WBRDIV   ( NMDIM, KMAX )    !" ԕς̂c
*
      REAL       DELT2
      INTEGER    NM, K, KK
*
      DELT2  = DELT*2.  
*
*"         < 1. d͔g̉ϕ >
*
      DO 1100 K = 1 , KMAX
         DO 1100 NM=1,NMDIM !"97/05/19xVF̍s DELT2*.. -> DELT*..
            WDTX  ( NM,K ) = WDT  ( NM,K )*( 1. - DELT*DIFT( NM ) )
     &                     + WTT  ( NM,K )* DELT
 1100 CONTINUE
*
      DO 1200 NM = 1 , NMDIM
            WDPIX ( NM )   = WDPI ( NM ) + WTPI  ( NM )* DELT
 1200 CONTINUE
*
*"         < 2. WI|eV >
*
      CALL WHYDRO
     O         ( WDPHIX,
     I           WDTX   )
*
*"         < 3. ỦE  >
*
      DO 3100 K = 1 , KMAX
*
         DO 3110 NM = 1 , NMDIM
*
            WBRDIV( NM,K )
     &       =  WDDIV( NM,K ) * ( 1. + DELT *DIFV( NM ) )
     &                        * ( 1. + DELT2*DIFT( NM ) )
     &           + DELT*(   WTDIV ( NM,K )
     &                    - FLAPLA( NM )
     &                      * (  WDPHIX( NM,K )
     &                           + ( 1. + DELT2*DIFT( NM ) )
     &                             * (  WPHIS ( NM )
     &                                + WDPIX ( NM )*GG( K ) )  )   )
*
 3110    CONTINUE
 3100 CONTINUE
*
*"         < 4. ԕς̂cLUsŉ >
*
      CALL LUSOLV
     M         ( WBRDIV,
     I           DMLU  , KPIV  ,
     D           1     , NMDIM , KMAX   )
*
*"         < 5. M, n\C̎ԕω >
*
      DO 5100 K = 1, KMAX
         DO 5100 KK = 1 , KMAX
            DO 5100 NM = 1, NMDIM
               WTT ( NM,K ) = WTT   ( NM,K )
     &                       - TMTX ( K,KK ) * WBRDIV( NM,KK )
 5100 CONTINUE
*
      DO 5200 KK = 1 , KMAX
         DO 5200 NM = 1, NMDIM
              WTPI ( NM   ) = WTPI  ( NM   )
     &                        - DSIG(   KK ) * WBRDIV( NM,KK )
 5200 CONTINUE
*
*"         < 7. Ԑϕ  gU͑O >
*
      DO 7100  K = 1 , KMAX
         DO 7100  NM = 1 , NMDIM
*
*"        ------------------  < Qx > ---------------------------
*
            WDVOR( NM,K ) = ( WDVOR( NM,K ) + WTVOR( NM,K )*DELT2 )
     &                     /( 1. + DELT2*DIFV( NM )               )
*
*"        ------------------  < U >  -------------------------
*
            WDDIV ( NM,K ) =  WBRDIV( NM,K )*2. - WDDIV ( NM,K )
*
*"        ------------------  < x >  -------------------------
*
            WDT  ( NM,K ) = ( WDT  ( NM,K ) + WTT  ( NM,K )*DELT2 )
     &                    / ( 1. + DELT2*DIFT( NM )               )
*
*"        ------------------  < 䎼 >  -------------------------
*
            WDQ  ( NM,K ) = ( WDQ  ( NM,K ) + WTQ  ( NM,K )*DELT2 )
     &                    / ( 1. + DELT2*DIFT( NM )               )
*
 7100 CONTINUE
*
      DO 7200 NM = 1 , NMDIM
*
*"        ------------------  < ln(n\C) >  --------------------
*
            WDPI ( NM   ) =   WDPI ( NM   ) + WTPI ( NM   )*DELT2
*
 7200 CONTINUE
*
      RETURN
      END
***********************************************************************
      SUBROUTINE MOVGD        !"  iq_l̈ړ
     O         ( GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     O           GBVOR , GBDIV ,
     I           GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GAVOR , GADIV                          )
*

#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" iq_Cg
#else
#include        "zcdim.F"                    !" iq_Cg
#endif
*
*   [OUTPUT] 
      REAL       GBU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GBV   ( IDIM, JDIM, KMAX )  !" 앗  
      REAL       GBT   ( IDIM, JDIM, KMAX )  !" x  s
      REAL       GBPS  ( IDIM, JDIM       )  !" n\C
      REAL       GBQ   ( IDIM, JDIM, KMAX )  !" 䎼  
      REAL       GBVOR ( IDIM, JDIM, KMAX )  !" Qx  
      REAL       GBDIV ( IDIM, JDIM, KMAX )  !" U  c
*"       : iq_f[^(t-t) ->  iq_f[^(t)
*
*   [INPUT] 
      REAL       GAU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GAV   ( IDIM, JDIM, KMAX )  !" 앗  
      REAL       GAT   ( IDIM, JDIM, KMAX )  !" x  s
      REAL       GAPS  ( IDIM, JDIM       )  !" n\C
      REAL       GAQ   ( IDIM, JDIM, KMAX )  !" 䎼  
      REAL       GAVOR ( IDIM, JDIM, KMAX )  !" Qx  
      REAL       GADIV ( IDIM, JDIM, KMAX )  !" U  c
*"       : iq_f[^(t)
*
      CALL COPY ( GBU   , GAU   , IDIM*JDIM*KMAX )
      CALL COPY ( GBV   , GAV   , IDIM*JDIM*KMAX )
      CALL COPY ( GBT   , GAT   , IDIM*JDIM*KMAX )
      CALL COPY ( GBPS  , GAPS  , IDIM*JDIM      )
      CALL COPY ( GBQ   , GAQ   , IDIM*JDIM*KMAX )
      CALL COPY ( GBVOR , GAVOR , IDIM*JDIM*KMAX )
      CALL COPY ( GBDIV , GADIV , IDIM*JDIM*KMAX )
*
      RETURN
      END
