* 1 dmtrx.F
* PACKAGE DMTRX !" ͊w Ԑϕps GCM5(DMTRX)
*
**********************************************************************
      SUBROUTINE DMTRIX        !" Ԑϕ ( XyNg ) pLUs
     O         ( DMLU  , KPIV  ,
     I           DELT  ,
     C           WHMTX , GCMTX ,
     C           NMO   , ER    , DIFV  , DIFT  )
*
*"              implicit diffusion
*
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 16 dmtrx.F
*
*   [OUTPUT] 
      REAL       DMLU  ( NMDIM, KMAX, KMAX ) !" rhŝkt
      INTEGER    KPIV  ( NMDIM, KMAX       ) !" rhs̃s{bg
*
*   [INPUT] 
      REAL       DELT                        !" ԍ݃t
      REAL       WHMTX ( KMAX, KMAX )        !" Z~CvVbgp
      REAL       GCMTX ( KMAX, KMAX )        !" Z~CvVbgp
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" XyNg̓Y
      REAL       ER                          !" na
      REAL       DIFV  ( NMDIM  )            !" ^ʐgUW
      REAL       DIFT  ( NMDIM  )            !" MCgUW
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           DM
      REAL       DM    ( KMAX, KMAX )        !" [N
      INTEGER    KMAXD
      PARAMETER  (KMAXD=100)
      INTEGER    KP    ( KMAXD )             !" s{bg
*
      INTEGER    MXNM, L, M, N, NM, K, KK
      REAL       FLAPLA
*
      IF  ( KMAX .GT. KMAXD ) THEN
         CALL MSGDMP( 'E','DMTRIX','INSUFFICIENT WORK STRAGE.')
      ENDIF
*
      MXNM = 0
*
      DO 3300 N = 0, NMAX
*"                                                 === LOOP N ===
*
*"         < 1. semi-implicit ̍s >
*
         FLAPLA = - REAL( N ) * REAL( N+1 ) / ER**2
*
         DO 1000 M = 0, MIN(N,MMAX), MINT
            IF ( N-M .LE. LMAX ) THEN
               NM = NMO( 1, M, N-M )
               GOTO 1010
            ENDIF
 1000    CONTINUE
*"                   no n(m,l) ----->  continue
         WRITE (6,*) ' WARNING [DMTRX]: N=', N, ' DOES NOT EXIST '
         GOTO 3300
*
 1010    CONTINUE
*
         DO 1100 K = 1, KMAX
            DO 1100 KK = 1, KMAX
               DM ( K,KK ) = - DELT**2 * FLAPLA
     &                         * (   WHMTX( K,KK )
     &                             + GCMTX( K,KK )
     &                               * ( 1. + DELT*2.*DIFT(NM) )  )
               IF ( K .EQ. KK) THEN
                  DM ( K,KK ) = DM ( K,KK )
     &                        +   ( 1. + DELT*2.* DIFV(NM) )
     &                          * ( 1. + DELT*2.* DIFT(NM) )
               ENDIF
 1100    CONTINUE
*
*"         < 2. LUs >
*
         CALL LUMAKE
     M         ( DM    ,
     O           KP    ,
     D           1     , KMAX   )
*
*"         < 3. z̋lߑւ >
*
         DO 3200 M = 0 , MMAX, MINT
            L = N - M
*
            IF (   ( L .GE. 0 ) .AND. ( L .LE. LMAX )   )THEN
               DO 3100 K = 1, KMAX
*
                  DO 3110 KK = 1, KMAX
                     DMLU ( NMO(1,M,L),K,KK ) = DM ( K,KK )
                     DMLU ( NMO(2,M,L),K,KK ) = DM ( K,KK )
 3110             CONTINUE
                  KPIV ( NMO(1,M,L),K ) = KP ( K )
                  KPIV ( NMO(2,M,L),K ) = KP ( K )
*
                  MXNM = MAX( MXNM, NMO(1,M,L) )
                  MXNM = MAX( MXNM, NMO(2,M,L) )
 3100          CONTINUE
            ENDIF
*
 3200    CONTINUE
*
*"                                                 === LOOP N ===
 3300 CONTINUE
*
      DO 4100 NM = MXNM+1, NMDIM
         DO 4100 K = 1, KMAX
             DO 4110 KK = 1, KMAX
                DMLU ( NM,K,KK ) = DM ( K,KK )
 4110        CONTINUE
             KPIV ( NM,K ) = KP ( K )
 4100 CONTINUE
            
      RETURN
      END
