* 1 ihsub.F
* PACKAGE IHSUB     !" qXg[pbP[W
*
*"   [HIS] 90/11/02(numaguti) Original
************************************************************************
      SUBROUTINE HSTADD    !" ԕσqXg[̑
     M         ( GOUT  ,
     I           GDATA , IMULT ,
     I           HCORD , HTYPE  )
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 15 ihsub.F
*   [MODIFY] 
      REAL       GOUT   ( * )
*
*   [INPUT] 
      REAL       GDATA  ( IDIM, JDIM, *  )
      INTEGER    IMULT
      CHARACTER  HCORD *(*)
      CHARACTER  HTYPE *(*)
*
*   [INTERNAL WORK] 
      REAL       GDATAW ( IDIM, JDIM, KMAX+1 )
      INTEGER    IMAXD, JMAXD, KMAXD
      INTEGER    II, I, J, K
*
      IF      ( HTYPE .EQ. 'X' ) THEN
         CALL XAVR
     I      ( GDATA , HCORD ,
     O        GDATAW, IMAXD , JMAXD , KMAXD  )
*
      ELSE IF ( HTYPE .EQ. 'Z' ) THEN
         CALL ZAVR
     I      ( GDATA , HCORD ,
     O        GDATAW, IMAXD , JMAXD , KMAXD  )
*
      ELSE IF ( HTYPE .EQ. 'XZ' ) THEN
         CALL XZAVR
     I      ( GDATA , HCORD ,
     O        GDATAW, IMAXD , JMAXD , KMAXD  )
*
      ELSE IF ( HTYPE .EQ. 'XY' ) THEN
         CALL XYAVR
     I      ( GDATA , HCORD ,
     O        GDATAW, IMAXD , JMAXD , KMAXD  )
*
      ELSE IF ( HTYPE .EQ. 'XYZ' ) THEN
         CALL XYZAVR
     I      ( GDATA , HCORD ,
     O        GDATAW, IMAXD , JMAXD , KMAXD  )
*
      ELSE
         CALL NOAVR
     I      ( GDATA , HCORD ,
     O        GDATAW, IMAXD , JMAXD , KMAXD  )
      ENDIF
*
      II = 0
      DO 1100 K = 1, KMAXD
         DO 1110 J = 1, JMAXD
            DO 1120 I = 1, IMAXD
               II = II + 1
               GOUT ( II ) = GOUT ( II ) + GDATAW( I,J,K )*IMULT
 1120       CONTINUE
 1110    CONTINUE
 1100 CONTINUE
*
      RETURN
      END
************************************************************************
      SUBROUTINE HHEDIT       !" ԕϕҏWLq
     M         ( HHEAD ,
     I           ITSUM , IMEAN , HUTIMO  )
*
*   [MODIFY] 
      CHARACTER  HHEAD ( * )*(*)             !" wb_[
*
*   [INPUT] 
      INTEGER    ITSUM                       !" ώZ
      INTEGER    IMEAN                       !" /ώZ
      CHARACTER  HUTIMO     *(*)             !" o͎P
*
*   [INTERNAL WORK] 
* 1 ..\include/zhdim.F
* PACKAGE ZHDIM  !" 񕶎 
*
*"  [HIS]  90/08/31(numaguti)
*
      INTEGER     NCC
      INTEGER     NDC
      INTEGER     NFILN
*
      PARAMETER ( NCC   = 16, NDC   = 64 ,
     &            NFILN = 100             )
* 91 ihsub.F
      CHARACTER  HEDIT      *(NCC)           !" P
      CHARACTER  HETTL      *(NCC)           !" P
      CHARACTER  HNUM       *(NCC)           !" P
      INTEGER    NNUM, NE
      REAL       RT
*
*   [EXTERNAL FUNC] 
      INTEGER    LENC
*
      CALL ACTIMR
     I         ( ITSUM , '#'   , HUTIMO,
     O           RT                        )
*
      CALL GZDBCR ( 'D', RT, HNUM, NNUM   )
      HETTL = HNUM(1:NNUM)//HUTIMO
      NE = LENC( HETTL )
*
      IF ( IMEAN .GT. 0 ) THEN
         HEDIT = 'TMEAN'
         HETTL(NE+1:NE+5) = ' Mean'
      ELSE
         HEDIT = 'TINTG'
         HETTL(NE+1:NE+5) = ' Intg'
      ENDIF
*
      CALL GHEADD( HHEAD , HEDIT  , HETTL )
*
      RETURN
      END
