* 1 usubs.F
* PACKAGE USUBS       !" G[`
*
*"  [HIS] 90/08/31(numaguti)
*
***********************************************************************
      SUBROUTINE RESET     !" zOZbg
     O         ( DATA  ,
     D           IDIM   )
*
*   [PARAM] 
      INTEGER    IDIM
*
*   [OUTPUT]       
      REAL       DATA ( IDIM )
*
*   [INTERNAL WORK] 
      INTEGER    I
*
      DO 1100 I = 1, IDIM
        DATA ( I ) = 0.  
 1100 CONTINUE
*
*
      RETURN
      END
***********************************************************************
      SUBROUTINE COPY     !" z𕡎
     O         ( DATAO  ,
     I           DATAI  ,
     D           IDIM     )
*
*   [PARAM]
      INTEGER    IDIM
*
*   [OUTPUT]       
      REAL       DATAO ( IDIM )                !" o̓f[^
*
*   [INPUT] 
      REAL       DATAI ( IDIM )                !" ̓f[^
*
*   [INTERNAL WORK] 
      INTEGER    I
*
      DO 1100 I = 1, IDIM
        DATAO ( I ) = DATAI ( I )
 1100 CONTINUE
*
      RETURN
      END
***********************************************************************
      SUBROUTINE SETV   !" zɃXJ[lZbg
     O         ( DATA  ,
     I           VALUE ,
     D           IDIM   )
*
*   [PARAM] 
      INTEGER    IDIM
*
*   [OUTPUT] 
      REAL       DATA ( IDIM )                 !" z
*
*   [INPUT] 
      REAL       VALUE                         !" ̓f[^
*
*   [INTERNAL WORK] 
      INTEGER    I
*
      DO 1100 I = 1, IDIM
        DATA ( I ) = VALUE
 1100 CONTINUE
*
      RETURN
      END
***********************************************************************
      SUBROUTINE FILLV  !" ẑ͈͂lŖ߂ >>
     M         ( DATA  ,
     I           VALUE ,
     D           IMIN  , IMAX  , IDIM  , JMIN  , JMAX  , JDIM  ,
     D           KMIN  , KMAX                                   )
*
*   [PARAM] 
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    KMAX
*
*   [MODIFY] 
      REAL       DATA ( IDIM, JDIM, KMAX )   !" zf[^
*
*   [INPUT] 
      REAL       VALUE                       !" ̓f[^
      INTEGER    IMIN                        !" Pn
      INTEGER    IMAX                        !" PI
      INTEGER    JMIN                        !" Qn
      INTEGER    JMAX                        !" QI
      INTEGER    KMIN                        !" Rn
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
*
      DO 1100 K = KMIN, KMAX
        DO 1100 J = JMIN, JMAX
          DO 1100 I = IMIN, IMAX
            DATA ( I, J, K ) = VALUE
 1100 CONTINUE
*
*
      RETURN
      END
************************************************************************
      SUBROUTINE MAXMIN      !"  z̍ŏlőlo 
     I         ( DATA, IDIM, JDIM, KMAX, IMAX, JMAX, HITEM )
*
*   [PARAM] 
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    KMAX
*
*   [INPUT] 
      REAL       DATA( IDIM, JDIM, KMAX )
      INTEGER    IMAX
      INTEGER    JMAX
      CHARACTER  HITEM*(*)                     !" \
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
      INTEGER    IPMIN, JPMIN, KPMIN
      INTEGER    IPMAX, JPMAX, KPMAX
      REAL       DMIN, DMAX
*
      DMIN =  1.E36
      DMAX = -1.E36
*
      DO 1100 K=1,KMAX
        DO 1100 J=1,JMAX
          DO 1100 I=1,IMAX
*
            IF ( DATA( I,J,K ) .LT. DMIN ) THEN
              DMIN = DATA( I,J,K )
              IPMIN = I
              JPMIN = J
              KPMIN = K
            ENDIF
*
            IF ( DATA( I,J,K ) .GT. DMAX ) THEN
              DMAX = DATA( I,J,K )
              IPMAX = I
              JPMAX = J
              KPMAX = K
            ENDIF
*
 1100 CONTINUE
*
      WRITE (6,*) HITEM, ': min = ', DMIN,' at ', IPMIN,JPMIN,KPMIN
      WRITE (6,*) HITEM, ': max = ', DMAX,' at ', IPMAX,JPMAX,KPMAX
*
      RETURN
      END
*********************************************************************
      INTEGER FUNCTION IUNITM  !" ԒPʂ̕ϊ
     I        ( KT    , HUNIT  , IDELT  )
*
*   [INPUT] 
      INTEGER     KT                          !" (PHUNIT)
      CHARACTER   HUNIT*(*)                   !" ԒP
      INTEGER     IDELT                       !" 
*
*   [INTERNAL WORK] 
      INTEGER    IT
*
      IF      (    ( HUNIT       .EQ. 'STEP' )
     &         .OR.( HUNIT       .EQ. 'step' )  ) THEN
*
*"         < 1. step ̂Ƃ P >
*
        IT = KT * IDELT
*
*"         < 2. sec, min, hour, day >
*
      ELSE IF (    ( HUNIT (1:1) .EQ. 'S' )
     &         .OR.( HUNIT (1:1) .EQ. 's' )  ) THEN
        IT = KT
*
      ELSE IF (    ( HUNIT (1:1) .EQ. 'M' )
     &         .OR.( HUNIT (1:1) .EQ. 'm' )  ) THEN
        IT = KT*60
*
      ELSE IF (    ( HUNIT (1:1) .EQ. 'H' )
     &         .OR.( HUNIT (1:1) .EQ. 'h' )  ) THEN
        IT = KT*60*60
*
      ELSE IF (    ( HUNIT (1:1) .EQ. 'D' )
     &         .OR.( HUNIT (1:1) .EQ. 'd' )  ) THEN
        IT = KT*60*60*24
*
      ELSE
*
*"         < 3. ȊO :  >
*
        IT = KT*60
        WRITE (6,*) 'UNIT = ',HUNIT , 'KT = ',KT
        WRITE (6,*) 'Pʂ܂Blij肵܂'
      ENDIF
*
      IUNITM = IT
*
      RETURN
      END
***********************************************************************
      INTEGER FUNCTION MALLOC  !" [N̈|C^[蓖
     I        ( LENGTH, IPMAX  )
*
*   [INPUT] 
      INTEGER LENGTH                         !" Ē
      INTEGER IPMAX                          !" ő̈
*
*   [INTERNAL SAVE] 
      INTEGER IP                             !" Ă|C^
      INTEGER IPP                            !" ɊĂ|C^
      DATA    IPP / 1 /
      SAVE    IPP
*
*   [ENTRY FUNC] 
      INTEGER    MFREE
*
      IF ( LENGTH .LE. 0 ) THEN
         CALL MSGDMP( 'E','MALLOC','ASSIGN LENGTH IS NEGATIVE.')
*
      ELSE
         IP  = IPP
         IPP = IP + LENGTH
         IF ( (IPP-1) .GT. IPMAX ) THEN
            WRITE ( 6,* ) ' **** FURTHER ',  IPP-IPMAX-1,
     &                    ' BYTES AT MINIMUM'
            CALL MSGDMP( 'E','MALLOC','WORK AREA IS NOT ENOUGH.')
         ENDIF
*
C        WRITE ( 6,* ) ' POINTER OK ...', IP
         MALLOC = IP
      ENDIF
*
      RETURN
*======================================================================
      ENTRY MFREE()       !" [N̈|C^[Zbg
*
      IPP   = 1
      MFREE = 1
*
      RETURN
      END
